#include <stdio.h>

typedef struct
{
  char day, month;
  int year;
}
date;

int is_leap_year (int year)
{
  if (year % 4 == 0)
    if (year % 100 == 0)
      if (year % 400 == 0)
        return 1;
      else
        return 0;
    else
      return 1;
  else
    return 0;
}

int days_in_month (int month, int year)
{
  if (month == 2)
    if (is_leap_year (year))
      return 29;
    else
      return 28;
  else if (month == 4 || month == 6 || month == 9 || month == 11)
    return 30;
  else
    return 31;
}

void date_print (date *d)
{
  printf ("%02d.%02d.%04d", d->day, d->month, d->year);
}

int date_set (date *d, char day, char month, int year)
{
  d->year = year;
  if (month > 0 && month <= 12)
    d->month = month;
  else
    return 0;
  if (day > 0 && day <= days_in_month (month, year))
    d->day = day;
  else
    return 0;
  return 1;
}

void date_next (date *d)
{
  d->day++;
  if (d->day > days_in_month (d->month, d->year))
    {
      d->month++;
      d->day = 1;
      if (d->month > 12)
        {
          d->year++;
          d->month = 1;
        }
    }
}

void check (char day, char month, int year)
{
  date d;
  if (date_set (&d, day, month, year))
    {
      date_print (&d);
      printf (" --> ");
      date_next (&d);
      date_print (&d);
      printf ("\n");
    }
  else
    printf ("%02d.%02d.%04d: invalid date\n", day, month, year);
}

int main (void)
{
  check (6, 11, 2018);
  check (29, 11, 2018);
  check (30, 11, 2018);
  check (31, 11, 2018);
  check (29, 12, 2018);
  check (30, 12, 2018);
  check (31, 12, 2018);
  check (28, 2, 2016);
  check (29, 2, 2016);
  check (30, 2, 2016);
  check (28, 2, 2015);
  check (29, 2, 2015);
  check (30, 2, 2015);
  check (31, 12, 2008);
  check (28, 2, 2000);
  check (29, 2, 2000);
  check (30, 2, 2000);
  check (28, 2, 1900);
  check (29, 2, 1900);
  check (30, 2, 1900);
  return 0;
}
