#include <stdio.h>
#include <stdlib.h>

#define ANIMAL     0
#define WITH_WINGS 1
#define WITH_LEGS  2

typedef struct
{
  int type;
  char *name;
} base;

typedef struct
{
  int type;
  char *name;
  int wings;
} with_wings;

typedef struct
{
  int type;
  char *name;
  int legs;
} with_legs;

typedef union
{
  base b;
  with_wings w;
  with_legs l;
} animal;

animal *new_with_wings (char *name, int wings)
{
  animal *a = malloc (sizeof (with_wings));
  a->b.type = WITH_WINGS;
  a->b.name = name;
  a->w.wings = wings;
  return a;
}

animal *new_with_legs (char *name, int legs)
{
  animal *a = malloc (sizeof (with_legs));
  a->b.type = WITH_LEGS;
  a->b.name = name;
  a->l.legs = legs;
  return a;
}

int main (void)
{
  animal *a[2] = { new_with_wings ("duck", 2),
                   new_with_legs ("cow", 4) };

  for (int i = 0; i < 2; i++)
    if (a[i]->b.type == WITH_LEGS)
      printf ("A %s has %d legs.\n", a[i]->b.name,
              a[i]->l.legs);
    else if (a[i]->b.type == WITH_WINGS)
      printf ("A %s has %d wings.\n", a[i]->b.name,
              a[i]->w.wings);
    else
      printf ("Error in animal: %s\n", a[i]->b.name);

  return 0;
}
