#include <stdio.h>
#include <stdlib.h>

#define FIFO_SIZE 10

int fifo[FIFO_SIZE];
int fifo_write_pointer = 0;
int fifo_read_pointer = 0;

void push (int x)
{
  int old_fifo_write_pointer = fifo_write_pointer;
  fifo_write_pointer++;
  if (fifo_write_pointer >= FIFO_SIZE)
    fifo_write_pointer = 0;
  if (fifo_write_pointer == fifo_read_pointer)
    {
      fprintf (stderr, "fifo overflow\n");
      exit (1);
    }
  else
    fifo[old_fifo_write_pointer] = x;
}

int pop (void)
{
  if (fifo_read_pointer == fifo_write_pointer)
    {
      fprintf (stderr, "fifo underflow\n");
      exit (1);
    }
  else
    {
      int result = fifo[fifo_read_pointer++];
      if (fifo_read_pointer >= FIFO_SIZE)
        fifo_read_pointer = 0;
      return result;
    }
}

int main (void)
{
  push (3);
  push (7);
  push (137);
  for (int i = 0; i < 42; i++)
    push (i);
  printf ("%d\n", pop ());
  printf ("%d\n", pop ());
  printf ("%d\n", pop ());
  push (42);
  printf ("%d\n", pop ());
  printf ("%d\n", pop ());
  return 0;
}
