#include <stdio.h>
#include <stdlib.h>

typedef struct
{
  char symbol;
  int (*calculate) (int a, int b);
}
operation;

operation *new_operation (void)
{
  operation *op = malloc (sizeof (operation));
  op->symbol = '?';
  op->calculate = NULL;
  return op;
}

int calculate_plus (int a, int b)
{
  return a + b;
}

operation *new_plus (void)
{
  operation *op = malloc (sizeof (operation));
  op->symbol = '+';
  op->calculate = calculate_plus;
  return op;
}

int calculate_minus (int a, int b)
{
  return a - b;
}

operation *new_minus (void)
{
  operation *op = malloc (sizeof (operation));
  op->symbol = '-';
  op->calculate = calculate_minus;
  return op;
}

int calculate_times (int a, int b)
{
  return a * b;
}

operation *new_times (void)
{
  operation *op = malloc (sizeof (operation));
  op->symbol = '*';
  op->calculate = calculate_times;
  return op;
}

int main (void)
{
  operation *op[4];
  op[0] = new_plus ();
  op[1] = new_minus ();
  op[2] = new_times ();
  op[3] = NULL;
  for (int i = 0; op[i]; i++)
    printf ("2 %c 3 = %d\n", op[i]->symbol, op[i]->calculate (2, 3));
  return 0;
}
