#include <stdio.h>
#include <string.h>

void sort (void **data, int (*compare) (void *x1, void *x2))
{
  for (int i = 0; data[i]; i++)
    for (int j = i + 1; data[j]; j++)
      if (compare (data[i], data[j]) > 0)
        {
          void *tmp = data[i];
          data[i] = data[j];
          data[j] = tmp;
        }
}

int compare_strings (void *x1, void *x2)
{
  return strcmp (x1, x2);
}

int compare_numbers (void *x1, void *x2)
{
  if (*(int *) x2 < *(int *) x1)
    return 1;
  else
    return 0;
}

int main (void)
{
  char *strings[] = { "Thomas", "Dora", "Konrad", "Adalbert", "Sophie", NULL };
  sort ((void **) strings, compare_strings);
  for (int i = 0; strings[i]; i++)
    printf ("%s\n", strings[i]);

  printf ("\n");

  int two = 2, ten = 10, zero = 0, three = 3, one = 1;
  int *numbers[] = { &two, &ten, &zero, &three, &one, NULL };
  sort ((void **) numbers, compare_numbers);
  for (int i = 0; numbers[i]; i++)
    printf ("%d\n", *numbers[i]);

  return 0;
}
